﻿Module Module1

    Sub Main()
        Dim IdentificadorMutex = String.Format("{0}_{1}", "A403A6EB-6472-4B42-B5C1-C0E06F9F25B3", System.Security.Principal.WindowsIdentity.GetCurrent().User)
        Using Mutex = New System.Threading.Mutex(True, IdentificadorMutex)
            'Dim Processo = System.Diagnostics.Process.GetCurrentProcess()
            'Dim JaEstaRodando = System.Diagnostics.Process.GetProcessesByName(Processo.ProcessName).Any(Function(P) P.Id <> Processo.Id)
            Dim JaEstaRodando = Not Mutex.WaitOne(0, True)
            'Dim JaEstaRodando = System.Diagnostics.Process.GetProcessesByName(Processo.ProcessName).Any(Function(P) P.Id <> Processo.Id And GetProcessOwner(P.Id) = GetProcessOwner(Processo.Id))

            If (JaEstaRodando) Then
                Console.WriteLine("Já está rodando!")
                Console.ReadLine()
                Return
            End If

            Console.WriteLine("Instância única")
            Console.ReadLine()
        End Using
    End Sub

    Public Function GetProcessOwner(ProcessId As Integer) As String
        Dim Query = "Select * From Win32_Process Where ProcessID = " & ProcessId
        Dim Searcher = New System.Management.ManagementObjectSearcher(Query)
        Dim ProcessList = Searcher.[Get]()

        For Each Obj As System.Management.ManagementObject In ProcessList
            Dim ArgList As String() = New String() {String.Empty, String.Empty}
            Dim ReturnVal As Integer = Convert.ToInt32(Obj.InvokeMethod("GetOwner", ArgList))
            If ReturnVal = 0 Then
                ' return DOMAIN\user
                Return ArgList(1) + "\" + ArgList(0)
            End If
        Next

        Return "NO OWNER"
    End Function
End Module
